/**************************************************
* tcp_func.h  V2.1 - Header fuer Windows (VS) UND Linux
* (C) JoEmbedded
***************************************************/

#ifdef __cplusplus
extern "C"{
#endif

//====== Ab hier WIN32-Header ======
#ifdef _MSC_VER
 #undef UNICODE

 #define _WINSOCK_DEPRECATED_NO_WARNINGS
 #include <winsock2.h>
 #include <ws2tcpip.h>
 #pragma comment (lib, "Ws2_32.lib")
 #define IP_ADDR(a)     (a##.sin_addr.S_un.S_addr) // Bissl ander gebaut auf PC/Linux

#else
 //====== Ab hier LINUX-Header ======
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <netdb.h>
 #include <errno.h>


 typedef int SOCKET;
 typedef struct timeval TIMEVAL;	  // dto.
 #define stricmp strcasecmp
 #define strnicmp strncasecmp
 #define closesocket 	close // dto.
 #define IP_ADDR(a)     ((&a)->sin_addr.s_addr)   // Bissl ander gebaut auf PC/Linux, geht nicht mit ##
 #define WSAEINTR  EINTR
 #define WSAEINVAL EINVAL

 #endif



void tf_init_tcp(void);
void tf_exit_tcp(void);

struct addrinfo* tf_init_addrinfo(char *hostname,char *service);
SOCKET tf_socket(struct addrinfo *paddrinfo);
void tf_bind(SOCKET lsock, struct addrinfo *paddrinfo);
void tf_listen(SOCKET lsock, int maxconn);
SOCKET tf_accept(SOCKET lsock,struct sockaddr_in *premoaddr);
int tf_recv(SOCKET rsocket, char* read_buf, int rsize);
int tf_send(SOCKET ssocket, char* write_buf, int wsize);
int tf_closesocket(SOCKET lsock);
int tf_rdselect1(SOCKET lsock, struct timeval* timeout);

SOCKET tf_create_server_socket(char *server_port, int maxclients);
SOCKET tf_create_client_socket(char* psn, char* psp);

#ifdef __cplusplus
}
#endif


// END

