/**********************************************************************
	WebConnector Test (VS Studio)
	Testmodul fuer  LTX-Protokoll - (C) JoEmbedded.de
	Typ. Aufrufe: http://localhost/wrk/m2ltx/big.php?a=100

	ErrorCodes: https://docs.microsoft.com/de-de/windows/win32/winsock/windows-sockets-error-codes-2
*/

#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <string.h>
#include "tcp_func.h"

/*************************************** Globals *****************************/
// Hier HTTP-Transfer definieren: (undefiniert)HTTP1.0 oder HTTP1.1
#define HTTP11 

//#define HOST "localhost"	// address of server
#define HOST "joembedded.de"	

#define PORT 80		// Server port
//#define PORT 443		// Beschwert sich wenn nicht SSL	

//#define SCRIPT "wrk/m2ltx/big.php"
#define SCRIPT "x3/wrk/m2ltx/big.php"

#define ARGS   "a=200"



char host[80] = HOST;   // Defaults
int port = PORT;
char script[160] = SCRIPT;
char sargs[1024] = ARGS;

#define WB_SIZE (1024*1024)    // Man weiss nie, Antwort kann LANG sein...
char buf[WB_SIZE];

/*************************************** Transfer *****************************/
int ltx_transfer(void) {
	SOCKET WebSocket;
	char sport[8];
	sprintf(sport, "%d", port);
	WebSocket = tf_create_client_socket(host, sport);	// Kann 2 Min. dauern
	if (!WebSocket) {
		printf("ERROR: Can't open TCP: '%s:%d'", host, port);
		return -1;  // Open Error
	}

	int res = -1;

	int hlen;
	int total = 0;

	// Header + Daten senden
	printf("==================== Header: ==================== \n");
	for (;;) {
#ifdef HTTP11
		hlen = sprintf(buf, "POST /%s?%s HTTP/1.1\r\n", script, sargs);
#else
		hlen = sprintf(buf, "POST /%s?%s HTTP/1.0\r\n", script, sargs);
#endif
		printf("%s", buf);
		total += hlen;
		if (hlen != tf_send(WebSocket, buf, hlen)) break;       // Schreibfehler

		hlen = sprintf(buf, "Host: %s:%u\r\n", host, port);
		printf("%s", buf);
		total += hlen;
		if (hlen != tf_send(WebSocket, buf, hlen)) break;       // Schreibfehler

		hlen = sprintf(buf,
#ifdef HTTP11
			"Connection: close\r\n" // nur HTTP/1.1
#endif
// Content-Length: 0
			"\r\n");
		printf("%s", buf);
		total += hlen;
		if (hlen != tf_send(WebSocket, buf, hlen)) break;       // Schreibfehler

		res = 0;
		break;
	}
	if (res) {
		printf("ERROR: Send Header\n");
		return -1;
	}
	else {
		printf("====================  (Sent: %d Bytes) ====================\n", total);
	}

	// Antwort lesen

	int maxtr = WB_SIZE - 1;      // max-2-Read
	char* pc = buf;
	int hres;
	TIMEVAL timeout;

	res = 0;
	for (;;) {
		timeout.tv_sec = 10;    // Wir warten max. 10 sec
		timeout.tv_usec = 0;
		hres = tf_rdselect1(WebSocket, &timeout);
		if (hres <= 0) {
			res = -1;
			break;
		}

		hres = tf_recv(WebSocket, pc, maxtr);
		if (hres <= 0) {	// Closed by Host
			break;
		}
		pc += hres; // soviel wurde gelesen
		maxtr -= hres;
		if (maxtr <= 0) {
			break;       // Mehr NICHT lesen
		}
	}
	*pc = 0;  // Als String terminieren

	total = strlen(buf);
	printf("====================  Reply(Result:%d): ==================== \n", res);
	printf("%s\n",buf);

	printf("==================== (Received: %d (/max %d) Bytes) ==================== \n", total, WB_SIZE);

	return 0;
}

/*************************************** MAIN *****************************/
int main(int argc, char* argv[])
{
	printf("*** WEBCON '%s' V1.0 (C) JoEmbedded.de ***\n", argv[0]);
	for (int i = 1; i < argc; i++) {
		if (!strncmp(argv[i], "-h", 2)) {
			strcpy_s(host, sizeof(host), argv[i]);
		}
		else if (!strncmp(argv[i], "-p", 2)) {
			port = atoi(argv[i]);
		}
		else if (!strncmp(argv[i], "-s", 2)) {
			strcpy_s(script, sizeof(script), argv[i]);
		}
		else if (!strncmp(argv[i], "-a", 2)) {
			strcpy_s(sargs, sizeof(sargs), argv[i]);
		}
		else {
			printf("ERROR: unknown option '%s'\n", argv[i]);
		}
	}
	printf("Host(-h): '%s', Port(-p): %d, Script(-t):'%s', Arguments(-a):'%s'\n", host, port, script, sargs);

	//Initialise winsock (not required on Linux)
	printf("Initialising Winsock...\n");
	tf_init_tcp();

	// Run Test-Transfer
	ltx_transfer();

	puts("*END*");
	tf_exit_tcp();

	return 0;
}

